#cs
Nom du programme : Puissance 4
Auteur : Spiikesan
Date : 30 mars 2012 12:37
Modification : ZDS le 11 avril 2012 11:25
#ce

#NoTrayIcon

#Include <GuiConstants.au3>
#Include <ButtonConstants.au3>

Global $JOUEURS = 3, $taille = 52 ; Taille des cases
Global $dimension[2] = [7,6], $LIGNE = 4 ; [Horizontal x Vertical] et taille de la ligne  faire pour gagner
Global $pion[$JOUEURS+1] = ["Images/PVide.bmp", "Images/PRouge.bmp", "Images/PJaune.bmp", "Images/PVert.bmp"] ; Images des pions
Global $joueurEnCours = 1

$GUI = GUICreate("Puissance "&$LIGNE, $dimension[0]*$taille, $dimension[1]*$taille+40)
$gui_Information = GUICtrlCreateLabel("", 0, 6*$taille+2, $dimension[0]*$taille, 25)
$gui_rejouer = GUICtrlCreateMenuItem("&Rejouer", GUICtrlCreateMenu("&Fichier"))

;~ Conception du plateau : 7 colonnes $i (de 0  6), 6 lignes $j (en partant du bas, de 0  5)
Global $grille[$dimension[0]][$dimension[1]]
For $i = 0 To $dimension[0]-1
	For $j = 0 To $dimension[1]-1
		$grille[$i][$j] = GUICtrlCreateButton("", $i*$taille, ($dimension[1]-1-$j)*$taille, $taille, $taille, $BS_BITMAP)
	Next
Next

; Initialisation de la grille
_rejouer()
GUISetState()
While True
    $msg = GUIGetMsg()
    Switch $msg
	Case $GUI_EVENT_CLOSE
		ExitLoop
    Case $gui_rejouer
		_rejouer()
	Case Else
		For $i = 0 To $dimension[0]-1
			For $j = 0 To $dimension[1]-1
				If $msg = $grille[$i][$j] Then _cocher($i)
			Next
		Next
	EndSwitch
WEnd
GUIDelete()
Exit

;;;;;;;;;;;;;;;;;; Fonctions annexes

; Dposer un jeton du joueur en cours dans la colonne
Func _cocher($inp)
	Local $win = 0
	For $j = 0 To $dimension[1]-1
		If GUICtrlRead($grille[$inp][$j]) = "0" Then
			_remplir($grille[$inp][$j], $joueurEnCours)
			$win = _valider($inp, $j)
			_changerJoueur()
			ExitLoop
		EndIf
	Next
	Local $texte = "C'est au joueur " &$joueurEnCours& " de jouer."
	If $win = 0 Then
		GUICtrlSetData($gui_Information, $texte)
	Else
		$texte = "Le joueur " &$win& " a gagn!"
		GUICtrlSetData($gui_Information, $texte)
		MsgBox(0,"Partie finie", $texte)
		_rejouer()
	EndIf
EndFunc

; Changer le joueur en cours
Func _changerJoueur()
	$joueurEnCours = $joueurEnCours + 1
	If $joueurEnCours > $JOUEURS Then $joueurEnCours = 1
EndFunc

; Remplir un bouton en fonction du joueur
Func _remplir($bouton, $valeur)
	GUICtrlSetData($bouton, $valeur)
	GUICtrlSetImage($bouton, $pion[$valeur])
EndFunc

; Rinitialiser la grille
Func _rejouer()
    $joueurEnCours = 1
	For $i = 0 To $dimension[0]-1
		For $j = 0 To $dimension[1]-1
			_remplir($grille[$i][$j], 0)
		Next
	Next
    GUICtrlSetData($gui_Information, "C'est au joueur 1 de commencer.")
EndFunc

; Valider la grille en fonction de la pose du pion
; => Retourne 0 si perdant, sinon numro du joueur gagnant
Func _valider($x, $y)
	; On verifie que la case a bien t coch par un des joueurs
	If GUICtrlRead($grille[$x][$y]) = "0" Then Return 0
	; Pour chaque orientation (ligne, colonne, diagonale NW.SE
	; et diagonale NE.SW),  partir d'un point donn, on a au
	; maximum 4 possibilits : X---, -X--, --X-, et ---X
	; (Dans le cas d'un Puiss4, n possibilits pour PuissN)
	Local $cases[$LIGNE][2]
	; Vrification des lignes passant par [$x,$y]
	For $t = 0 To $LIGNE-1 ; 4 possibilits
		For $k = 0 To $LIGNE-1 ; 4 cases  vrifier
			$cases[$k][0] = $x-$t+$k
			$cases[$k][1] = $y
		Next
		Local $gagnant = _gagner($cases)
		If $gagnant <> 0 Then Return $gagnant
	Next
	; Vrification des colonnes passant par [$x,$y]
	For $t = 0 To $LIGNE-1 ; 4 possibilits
		For $k = 0 To $LIGNE-1 ; 4 cases  vrifier
			$cases[$k][0] = $x
			$cases[$k][1] = $y-$t+$k
		Next
		Local $gagnant = _gagner($cases)
		If $gagnant <> 0 Then Return $gagnant
	Next
	; Vrification des diagonales NESW passant par [$x,$y]
	For $t = 0 To $LIGNE-1 ; 4 possibilits
		For $k = 0 To $LIGNE-1 ; 4 cases  vrifier
			$cases[$k][0] = $x-$t+$k
			$cases[$k][1] = $y-$t+$k
		Next
		Local $gagnant = _gagner($cases)
		If $gagnant <> 0 Then Return $gagnant
	Next
	; Vrification des diagonales NWSE passant par [$x,$y]
	For $t = 0 To $LIGNE-1 ; 4 possibilits
		For $k = 0 To $LIGNE-1 ; 4 cases  vrifier
			$cases[$k][0] = $x-$t+$k
			$cases[$k][1] = $y+$t-$k
		Next
		Local $gagnant = _gagner($cases)
		If $gagnant <> 0 Then Return $gagnant
	Next
	Return 0
EndFunc

; Vrifie si les cases fournies ne sortent pas de la grille et qu'elle forment une ligne
; => Retourne 0 si perdant, sinon numro du joueur gagnant
Func _gagner($cases)
	For $k = 0 To $LIGNE-1
		For $d = 0 To 1
			If $cases[$k][$d]<0 Or $cases[$k][$d]>=$dimension[$d] Then Return 0
		Next
	Next
	Local $valeur = GUICtrlRead($grille[$cases[0][0]][$cases[0][1]])
	For $k = 1 To $LIGNE-1
		If GUICtrlRead($grille[$cases[$k][0]][$cases[$k][1]]) <> $valeur Then Return 0
	Next
	Return Number($valeur)
EndFunc